
#ifndef _GLOBAL_H
#define _GLOBAL_H

// #undef NDEBUG       // turn on debugging
#define NDEBUG      // turn off debugging


#ifdef NDEBUG
#  define DEBUG(stream_part)
#else
#  define DEBUG(stream_part) std::cerr << stream_part << std::endl;
#endif


#ifdef __GNUC__
#  if __GNUC__ < 3
#    include <hash_set.h>
#    include <hash_map.h>
     namespace Sgi { using ::hash_map; }; // inherit globals
#  else
#    include <ext/hash_set>
#    include <ext/hash_map>
#    if __GNUC_MINOR__ == 0
       namespace Sgi = std;               // GCC 3.0
#    else
       namespace Sgi = ::__gnu_cxx;       // GCC 3.1 and later
#    endif
#  endif
#else                                     // other compilers
#  include <hash_set.h>
#  include <hash_map.h>
   namespace Sgi = std;
#endif


#define FORALLENUM(type,var,begin,end,inc) \
        for( type var = begin; var <= end; var = (type)((int)var + inc) )


namespace std {

template<>
inline void swap( int &a_, int &b_ )
{
    a_ ^= b_;
    b_ ^= a_;
    a_ ^= b_;
}

} /* namespace std */


namespace blazi {

template<class C>
struct PtrHash
{
    size_t operator()( const C *ptr_ ) const { return (size_t)ptr_; }
};

} /* namespace blazi */


#endif /* _GLOBAL_H */

