
#include <cmath>
#include "_Loc.H"


sint4 blazi::Loc::distance( const Loc &loc_a_, const Loc &loc_b_ )
{
    sint4 dx = loc_a_.x - loc_b_.x;
    sint4 dy = loc_a_.y - loc_b_.y;
    return (sint4)sqrt( dx * dx + dy * dy );
}


sint4 blazi::Loc::hamilton_distance( const Loc &loc_a_, const Loc &loc_b_ )
{
    return std::abs( loc_a_.x - loc_b_.x ) +
           std::abs( loc_a_.y - loc_b_.y );
}


blazi::Loc blazi::Loc::away( const Loc &away_, const Loc &now_, sint4 with_ )
{
    sint4 sX = now_.x - away_.x;
    if( sX ) sX = (0 > sX) ? -1 : 1;

    sint4 sY = now_.y - away_.y;
    if( sY ) sY = (0 > sY) ? -1 : 1;

    return Loc( now_.x + sX * with_, now_.y + sY * with_ );
}


blazi::Loc blazi::Loc::avg( const Loc &loc_a_, const Loc &loc_b_ )
{
    return Loc( (loc_a_.x + loc_b_.x) / 2,
                (loc_a_.y + loc_b_.y) / 2 );
}

