/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <string>
using namespace std;

const QString WINDOWS_REGISTRY = "/QtExamples";
const QString APP_KEY = "/LoginDialog/";

void LoginDialog::init(){
    passLineEdit->setEchoMode( QLineEdit::Password );
    reg_passLineEdit->setEchoMode( QLineEdit::Password );
    reg_confirmpassLineEdit->setEchoMode( QLineEdit::Password );
    Xlocation = 450; // X position of LoginDialog
    Ylocation = 400; // Y position of LoginDialog
    loadSettings();
    user = "";
    if (nameLineEdit->text()=="")
    {
	passLineEdit->setFocus();
    }
    else
    {
	nameLineEdit->setFocus();
    }
}

void LoginDialog::processLoginInfo()
{
    REM("---- processLoginInfo ----");
    string name = nameLineEdit->text();
    string password = passLineEdit->text();
    int user_type= user_typeComboBox->currentItem();
    Level level = GENERAL;// default user
    switch(user_type)
    {
	case 0: level = GENERAL; break;	
	case 1: level = SUPER; break;
	case 2: level = WORKER; break;
	case 3: level = ROOT; break;
	default: REM(" NO MATCHING LEVEL "); break;
    }
    string server_ip = serverComboBox->currentText();
    string port = portLineEdit->text();
    string servicename = serviceComboBox->currentText();
    string confirmpw = "blah"; // just to make this paramter appear as filled in
    if(checkDialog(name, password, confirmpw, server_ip, port, servicename))
    {
	ahandler->login( name, password, level, server_ip, port, servicename );
	setUser( name ); // remember name for settings functionality 
	saveSettings();
	// Reset widgets
	passLineEdit->clear();
    }
}	

void LoginDialog::processRegisterInfo()
{
    string password = reg_passLineEdit->text();
    string confirmpassword = reg_confirmpassLineEdit->text();
    if( password != confirmpassword ){
	cout << "password and confirm pass are not the same!" << endl;
	error.showError("Password confirmation failed");
	return;
    }   
    string name = reg_nameLineEdit->text();
    int user_type= reg_user_typeComboBox->currentItem();
    int level;
    switch(user_type)
    {
	case 0: level = GENERAL; break;	
	case 1: level = SUPER; break;
	case 2: level = WORKER; break;
	case 3: level = ROOT; break;	
	default: REM(" NO MATCHING LEVEL "); 
		 level = -1;
		 break;
    }
    string server_ip = reg_serverComboBox->currentText();
    string port = reg_portLineEdit->text();
    string servicename = reg_serviceComboBox->currentText();
    /*
    string register_str = "register";
    register_str += " ";
    register_str += level; 
    register_str += " ";
    register_str += name;
    register_str += " ";
    register_str += password;
    cout << "register_str: "<< register_str << endl;;*/
    if(checkDialog(name, password, confirmpassword, server_ip, port, servicename))
    {
	ahandler->GGSlogin(name, password, server_ip, port, servicename);
	ahandler->tellService( Register::compose(level, name, password) );
	nameLineEdit->setText(reg_nameLineEdit->text());
	passLineEdit->setFocus();
	switchLogin();
    }
}

/**
  Check Login Dialog to see if all fields are 
  filled
  */
bool LoginDialog::checkDialog(string &name, string &pass, string &confirmpw, string &server_ip, string &port, string &servicename)
{
    if(name == "" || pass == "" || confirmpw == "" || server_ip == "" || port == "" || servicename == ""){
	error.showError("Please fill in all fields");
	cout << "PLEASE FILL IN ALL FIELDS" << endl; 
	return false;
    }
    return true;
}

void LoginDialog::setup(Handler *handler, QMainWindow *mwindow)
{
    ahandler = handler;
    mainWindow = mwindow;
    this->setFixedSize(this->width(),this->height());
}

void LoginDialog::showFirstPage()
{
    cout << "first"<< endl;
    int id =Reg_LogWidgetStack->id( loginPage );
    id = 0; // TODO: do something with id, for now shut up the compiler warning
}


void LoginDialog::switchLogin()
{
    cout << "switchlogin"<< endl;
    int id = Reg_LogWidgetStack->id( loginPage );
    Reg_LogWidgetStack->raiseWidget(id);
    Reg_OkPushButton->setDefault(false);
    okPushButton->setDefault(true);
}


void LoginDialog::switchRegister()
{
    cout << "REGISTER" << endl;
    int id = Reg_LogWidgetStack->id( registerPage );
    Reg_LogWidgetStack->raiseWidget(id);
    okPushButton->setDefault(false);
    Reg_OkPushButton->setDefault(true);
}


void LoginDialog::exitortsNetGui()
{	
    REM("[---- closing ortsNetGui ----]");
    saveSettings();
    exit(0);
}

void LoginDialog::saveSettings()
{
    REM("[ -- saving settings -- ]");
    QSettings settings;
    settings.insertSearchPath( QSettings::Windows, WINDOWS_REGISTRY );
    settings.writeEntry( APP_KEY + "WindowWidth", width() );
    settings.writeEntry( APP_KEY + "WindowHeight", height() );
    //settings.writeEntry( APP_KEY + "WindowX", x() );
    //settings.writeEntry( APP_KEY + "WindowY", y() );
    QString quser = (QString) getUser();
    /*bool user =*/ settings.writeEntry( APP_KEY + "User", quser );
    //if(!user) cout << "could not write" << endl;
    //string suser = quser;
    //cout << "uesr:"<<suser << endl;
}

void LoginDialog::loadSettings()
{
    REM("[ -- loading settings -- ]");
    QSettings settings;
    settings.insertSearchPath( QSettings::Windows, WINDOWS_REGISTRY );
    //int windowWidth = settings.readNumEntry( APP_KEY + "WindowWidth", 0 );
    //int windowHeight = settings.readNumEntry( APP_KEY + "WindowHeight", 0 );
    //int windowX = settings.readNumEntry( APP_KEY + "WindowX", 350 );
    //int windowY = settings.readNumEntry( APP_KEY + "WindowY", 300 );
    
    QString quser = settings.readEntry( APP_KEY + "User", "");
    string user = quser;
    
    nameLineEdit->setText( quser );
    //resize( windowWidth, windowHeight );
    //move( Xlocation, Ylocation );
}

void LoginDialog::setUser( string &name )
{
    user = name;
}

string LoginDialog::getUser()
{
    return user;
}


