#ifndef ScriptString_H
#define ScriptString_H

/** @file ScriptString.H
    Derived vector object.

    $Id: ScriptString.H,v 1.11 2007/02/12 02:46:34 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/ScriptString.H,v $
*/

// This is an ORTS file (c) Tim Furtak

#include "GameObj.H"

class ObjAction;
class PlayerInfo;
class SActParam;

//===================================================================

class ScriptString : public ScriptObj {
  
  Vector<ObjAction*> actions;
  std::map<std::string, ObjAction*> act_map;

public:
  std::string data;
  std::string prev_data;

  ScriptString();
  static ScriptObj *create() { return new ScriptString; }

  stype op       (const SActParam&);
  stype init     (const SActParam&);
  stype clear    (const SActParam&);
  stype size     (const SActParam&);
  stype append   (const SActParam&);
  stype add_char (const SActParam&);
  stype c_str    (const SActParam&);
  stype num_lines(const SActParam&);
  stype max_line (const SActParam&);

  std::string bp_name() const { return "ScriptObjString"; }

  ObjAction* action(const std::string &name) const;
  ObjAction* action(sint4) const { return actions[0]; }

  void gen_diff(bool, bool, std::string &, PlayerInfo *) const;
  bool apply_diff(bool, ByteStream &, PlayerInfo *);

  void copy_to_prev();

private:
  typedef stype (ScriptString::*myfunc)(const SActParam&);
  void add(const std::string &name, myfunc f, sint4 objs, sint4 p, sint4 p2);
};

#endif
