#include "pr_reservationProvider.H"
#include "bitVector.h"

namespace HOG{

PR_ReservationProvider::PR_ReservationProvider(int size)
{
  bitVec = new bitVector(size);
}

PR_ReservationProvider::~PR_ReservationProvider() {
  delete bitVec;
}
    
bool PR_ReservationProvider::nodeOccupied(node *n)
{
  uint4 nodeNum = n->getNum();
  return bitVec->get(nodeNum);
}                           
bool PR_ReservationProvider::canMove(node* /*from*/, node* /*to*/, double /*startTime*/, unit* /**u*/)
{
  return true;
}
bool PR_ReservationProvider::reserveMove(node* /*from*/, node* /*to*/, double /*startTime*/, unit* /**u*/)
{
  return true;
}
bool PR_ReservationProvider::clearMove(node* /*from*/, node* /*to*/, double /*startTime*/, unit* /**u*/)
{
  return true;
}

void PR_ReservationProvider::clearAllReservations()
{
  bitVec->clear();
}

void PR_ReservationProvider::setNodeStatus(node *n, bool status){
  bitVec->set(n->getNum(), status);
}
}
