/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef ServerClient_H
#define ServerClient_H

// represents a client on the server side

#include "Global.H"
#include "String.H"
#include "SocketBuffer.H"

class Server;

class ServerClient {

protected:

  SocketBuffer sb;
  String host;
  bool logged_in;

public:
  
  void init();

  ServerClient(sint4 ibl=32768, sint4 obl=32768) : sb(ibl, obl) { init(); }
  
  void close();
  bool is_closed();

  // true <=> blocked
  sint4 write_msg(const string &msg, bool blocking);
  sint4 write_flush();
  sint4 read_msg(string &msg);
  
  // virtual void actions() = 0;

  virtual ~ServerClient() {}

  friend class Server;
};

#endif

