#!/bin/bash
# Run a match between orts AI #1 and orts AI #2 (specified below)
if [ -z "$1" ]
then
  echo ' '
  echo 'syntax:'
  echo '  run_match.sh <number of games> <player 1 opt> <player 2 opt>'
  echo ' '
  echo 'example:'
  echo "  run_match.sh 100 '-ai flag' '-ai random' "
  echo ' '
  exit
fi

NUM_GAMES=$1
PLAYER_1_OPTS=$2
PLAYER_2_OPTS=$3

#echo 'Number of games = ' $NUM_GAMES
#echo 'Player 1:' $PLAYER_1_OPTS
#echo 'Player 2:' $PLAYER_2_OPTS

# Internal Parameters (shouldn't need to be modified)
GAME_LOG=game_log.tmp
RESULTS_LOG=results_log.tmp
WIN_TEXT='wins'
SLEEP_DELAY=1
OPTS='-disp 1'
FRAME_RATE=8
P1_LOG=p1.log
P2_LOG=p2.log

# change to correct directory
cd ..

echo '.' 1> $RESULTS_LOG
for ((i=1; i<=NUM_GAMES; i++))
do
  # start server
  sleep $SLEEP_DELAY
  ./ortsmap -out ctf.map -type ctf
  ./orts -loadmap ctf.map -m server -synchro 1 -f $FRAME_RATE 1> $GAME_LOG &
  
  # start client 1
  sleep $SLEEP_DELAY
  #xterm -e ./ortsai $OPTS $PLAYER_1_OPTS &
  ./ortsai $OPTS $PLAYER_1_OPTS 1> $P1_LOG &
  
  # start client 2
  sleep $SLEEP_DELAY
  #xterm -e ./ortsai $OPTS $PLAYER_2_OPTS
  ./ortsai $OPTS $PLAYER_2_OPTS 1> $P2_LOG

  grep $WIN_TEXT $GAME_LOG 1>> $RESULTS_LOG
  mv $GAME_LOG $GAME_LOG.old
done

# note: player 0 is player 1, 1 is 2...
echo 'Player 1 wins: ' $PLAYER_1_OPTS
grep 'Player 0 wins' $RESULTS_LOG | wc -l
grep 'Player 0 wins' $RESULTS_LOG > player1.wins
echo 'Player 2 wins: ' $PLAYER_2_OPTS
grep 'Player 1 wins' $RESULTS_LOG | wc -l
grep 'Player 1 wins' $RESULTS_LOG > player2.wins
echo '---'

mv $RESULTS_LOG $RESULTS_LOG.old
